// ThreadFPUstate.m
//
// History :
//		10.09.92 : created by Max Tardiveau

#import "ThreadFPUstate.h"

@implementation ThreadFPUstate


////////////////////////////////////////////////////////////////
//

#define MAXRETRIES 3		// Number of times to retry when uninterruptible

- doUpdateForCell:theCell
{
kern_return_t						error;
struct thread_basic_info			basicInfo;
unsigned int						basicInfo_count = THREAD_BASIC_INFO_COUNT;
struct NeXT_thread_state_68882		registers;
unsigned int						regCount = NeXT_THREAD_STATE_68882_COUNT;
char								tmpChar[40];
int									i;

[theCell setUpdater:self];

// Can't examin own thread
if ((thread_t)[theCell freePointer] == thread_self())
	{
	for (i = 0; i < 8; i++)
		[[FPmatrix cellAt:i :0] setStringValue:""];
	[ControlRegister setStringValue:""];
	[StatusRegister setStringValue:""];
	[InstructionAddressRegister setStringValue:""];
	[ExecStateRegister setStringValue:"Darnit !"];
	[errorText setStringValue:"You can't examin your own thread."];
	[errorPanel makeKeyAndOrderFront:self];
	return self;
	}

// Can't examin uninterruptible thread
for (i = 0; i < MAXRETRIES; i++)
	{
	error = thread_info((thread_t)[theCell freePointer], THREAD_BASIC_INFO, 
								(thread_info_t)&basicInfo, &basicInfo_count);
	if (error != KERN_SUCCESS)
		{
		[MyMaster addMessage:"ThreadCPUstate : error calling thread_info.\n"];
		return self;
		}
	if (basicInfo.run_state == TH_STATE_UNINTERRUPTIBLE)
		usleep(10000);
	else
		break;
	}

if (basicInfo.run_state == TH_STATE_UNINTERRUPTIBLE)
	{
	for (i = 0; i < 8; i++)
		[[FPmatrix cellAt:i :0] setStringValue:"Error"];
	[ControlRegister setStringValue:"Error"];
	[StatusRegister setStringValue:"Error"];
	[InstructionAddressRegister setStringValue:"Error"];
	[ExecStateRegister setStringValue:"Error"];
	[errorText setStringValue:"You can't examin an uninterruptible thread."];
	[errorPanel makeKeyAndOrderFront:self];
	return self;
	}

// Everything OK, go ahead
error = thread_get_state((thread_t)[theCell freePointer], 
					NeXT_THREAD_STATE_68882, (int *) &registers, &regCount);
if (error != KERN_SUCCESS)
	{
	if (error == MIG_ARRAY_TOO_LARGE)
		fprintf(stderr,
			"ThreadFPUstate : array too large in thread_get_state().\n");
	else if (error == KERN_INVALID_ARGUMENT)
		fprintf(stderr,
			"ThreadFPUstate : invalid arg in thread_get_state().\n");
	else
		fprintf(stderr,
			"ThreadFPUstate : error in thread_get_state().\n");
		
	for (i = 0; i < 8; i++)
		[[FPmatrix cellAt:i :0] setStringValue:"Error"];
	[ControlRegister setStringValue:"Error"];
	[StatusRegister setStringValue:"Error"];
	[InstructionAddressRegister setStringValue:"Error"];
	[ExecStateRegister setStringValue:"Error"];
	}
else
	{
	for (i = 0; i < 8; i++)
		{
		sprintf(tmpChar, "%0#.8x%0.8x%0.8x", registers.regs[i].fp[0],
				registers.regs[i].fp[1], registers.regs[i].fp[2]);
		[[FPmatrix cellAt:i :0] setStringValue:tmpChar];
		}
	sprintf(tmpChar, "%0#.8x", registers.cr);
	[ControlRegister setStringValue:tmpChar];
	sprintf(tmpChar, "%0#.8x", registers.sr);
	[StatusRegister setStringValue:tmpChar];
	sprintf(tmpChar, "%0#.8x", registers.iar);
	[InstructionAddressRegister setStringValue:tmpChar];
	sprintf(tmpChar, "%0#.8x", registers.state);
	[ExecStateRegister setStringValue:tmpChar];
	}

return self;
}

////////////////////////////////////////////////////////////////
//

- errorOK:sender
{
[NXApp stopModal];
[errorPanel performClose:self];

return self;
}

////////////////////////////////////////////////////////////////
//

- (int) updateInterval
{
return 5;
}

@end
