// ThreadGraphs.m
//

#import "ThreadGraphs.h"

@implementation ThreadGraphs


////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
kern_return_t				error;
struct thread_basic_info	basicInfo;
unsigned int				basicInfo_count = THREAD_BASIC_INFO_COUNT;

[theCell setUpdater:self];

if ( ! running)
	{
	[userGraph initMin:0 max:0.1 title:"User time" numFormat:"%.3f"];
	[systemGraph initMin:0 max:0.5 title:"System time" numFormat:"%.3f"];
	[CPUGraph initMin:0 max:0 title:"CPU use" numFormat:"%.3f"];
	running = YES;
	}

error = thread_info((thread_t)[theCell freePointer], THREAD_BASIC_INFO, 
								(thread_info_t)&basicInfo, &basicInfo_count);
if (error != KERN_SUCCESS)
	{
	[MyMaster addMessage:"ThreadGraphs : error in thread_info()\n"];
	return self;
	}

[userGraph addDeltaPoint:basicInfo.user_time.seconds + 
							(basicInfo.user_time.microseconds / 1000000.0)];
[systemGraph addDeltaPoint:basicInfo.system_time.seconds + 
							(basicInfo.system_time.microseconds / 1000000.0)];
[CPUGraph addPoint:basicInfo.cpu_usage];

return self;
}

////////////////////////////////////////////////////////////////
//

- (int) updateInterval
{
return 3;
}

@end
